/*
 * Copyright (c) 2011 Kristaps Dzonsons <kristaps@bsd.lv>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#include <assert.h>
#include <stdlib.h>

#include "extern.h"

void
expr_write(struct writer *p, enum rule r, const struct expr *ep)
{

	(*p->write)(r, ep, p->arg);
}

void
expr_write_open(struct writer *p)
{

	(*p->write_open)(p->arg);
}

void
expr_write_start(struct writer *p, const struct sym *sym)
{

	(*p->write_start)(sym, p->arg);
}

void
expr_write_end(struct writer *p, const struct expr *ep)
{

	(*p->write_end)(ep, p->arg);
}

void
expr_write_close(struct writer *p)
{

	(*p->write_close)(p->arg);
}

void
expr_write_free(struct writer *p)
{

	(*p->write_free)(p->arg);
	free(p);
}
